PROGRAM_NAME='RmsCommon'
(***********************************************************)
(*  FILE CREATED ON: 11/13/2018  AT: 11:47:02              *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 11/13/2018  AT: 12:23:05        *)
(***********************************************************)

// Stuff borrowed from RMS SDK

#IF_NOT_DEFINED IsRmsReady
DEFINE_FUNCTION CHAR IsRmsReady()
{
  RETURN ([vdvRMS,RMS_CHANNEL_ASSETS_REGISTER] && assetRegistered);
}
#END_IF


(**********************************************************)
(* Call Name: GetOnlineSnapiValue                         *)
(* Function:  Return device's online state.               *)
(**********************************************************)
#IF_NOT_DEFINED GetOnlineSnapiValue
DEFINE_FUNCTION INTEGER GetOnlineSnapiValue(DEV device)
{
  // the physical device must be online and the SNAPI
  // channel for DATA_INITIALIZED must be turned on
  RETURN(DEVICE_ID(device) && [vdvDeviceModule,DEVICE_COMMUNICATING])
}
#END_IF


(**********************************************************)
(* Call Name: GetDataInitializedSnapiValue                *)
(* Function:  Return device's data initialized state.     *)
(**********************************************************)
#IF_NOT_DEFINED GetDataInitializedSnapiValue
DEFINE_FUNCTION CHAR GetDataInitializedSnapiValue(DEV device)
{
  // the physical device must be online and the SNAPI
  // channel for DATA_INITIALIZED must be turned on
  RETURN(DEVICE_ID(device) && [vdvDeviceModule,DATA_INITIALIZED])
}
#END_IF

#IF_NOT_DEFINED stringTrim
DEFINE_FUNCTION INTEGER stringLTrim(CHAR strTXT[RMS_MAX_PARAM_LEN])
STACK_VAR
  INTEGER nTrimmed
{
  WHILE(LENGTH_STRING(strTXT)) {
    IF(strTXT[1] == $20 || strTXT[1] == $00) {
      GET_BUFFER_CHAR(strTXT)
      nTrimmed++
    }
    ELSE {
      BREAK
    }
  }

  RETURN(nTrimmed)
}

DEFINE_FUNCTION INTEGER stringRTrim(CHAR strTXT[RMS_MAX_PARAM_LEN])
STACK_VAR
  INTEGER nTrimmed
{
  WHILE(LENGTH_STRING(strTXT)) {
    IF(strTXT[LENGTH_STRING(strTXT)] == $20 || strTXT[LENGTH_STRING(strTXT)] == $00) {
      SET_LENGTH_STRING(strTXT,LENGTH_STRING(strTXT)-1)
      nTrimmed++
    }
    ELSE {
      BREAK
    }
  }

  RETURN(nTrimmed)
}

DEFINE_FUNCTION CHAR[RMS_MAX_PARAM_LEN] stringTrim(CHAR strTXT[RMS_MAX_PARAM_LEN])
{
  stringLTrim(strTXT)
  stringRTrim(strTXT)

  RETURN(strTXT)
}
#END_IF
