PROGRAM_NAME='rmsMeeting'
#include 'SNAPI';

(***********************************************************)
(*  FILE CREATED ON: 07/11/2019  AT: 13:02:15              *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/16/2020  AT: 11:05:42        *)
(***********************************************************)

#DEFINE INCLUDE_SCHEDULING_EVENT_STARTED_CALLBACK
#DEFINE INCLUDE_SCHEDULING_EVENT_ENDED_CALLBACK
#DEFINE INCLUDE_SCHEDULING_CREATE_RESPONSE_FEEDBACK
#include 'RmsSchedulingApi';

(***********************************************************)
(* Name:  RmsEventSchedulingCreateResponse                 *)
(* Args:                                                   *)
(* CHAR isDefaultLocation - boolean, TRUE if th location   *)
(* in the response is the default location                 *)
(*                                                         *)
(* CHAR responseText[] - Booking ID if successful else     *)
(* some error information.                                 *)
(*                                                         *)
(* RmsEventBookingResponse eventBookingResponse - A        *)
(* structure with additional booking information           *)
(*                                                         *)
(* Desc:  Implementations of this method will be called    *)
(* in response to a booking creation request               *)
(*                                                         *)
(***********************************************************)
DEFINE_FUNCTION RmsEventSchedulingCreateResponse(CHAR isDefaultLocation, 
						 CHAR responseText[], 
						 RmsEventBookingResponse eventBookingResponse)
{
    amx_log(AMX_ERROR,"'RmsEventSchedulingCreateResponse(',eventBookingResponse.location,',' ,
							   eventBookingResponse.subject,',',
							   responseText,')'");
}

(***********************************************************)
(* Name:  RmsEventSchedulingEventEnded                     *)
(* Args:                                                   *)
(* CHAR bookingId[] - The booking ID string                *)
(*                                                         *)
(* RmsEventBookingResponse eventBookingResponse - A        *)
(* structure with additional booking information           *)
(*                                                         *)
(* Desc:  Implementations of this method will be called    *)
(* when RMS indicates a booking event has ended            *)
(*                                                         *)
(***********************************************************)
DEFINE_FUNCTION RmsEventSchedulingEventEnded(CHAR bookingId[], RmsEventBookingResponse eventBookingResponse)
{
    amx_log(AMX_ERROR,"'RmsEventSchedulingEventEnded(',eventBookingResponse.location,',' ,eventBookingResponse.subject,')'");
}

(***********************************************************)
(* Name:  RmsEventSchedulingEventStarted                   *)
(* Args:                                                   *)
(* CHAR bookingId[] - The booking ID string                *)
(*                                                         *)
(* RmsEventBookingResponse eventBookingResponse - A        *)
(* structure with additional booking information           *)
(*                                                         *)
(* Desc:  Implementations of this method will be called    *)
(* when RMS indicates a booking event has started          *)
(*                                                         *)
(***********************************************************)
DEFINE_FUNCTION RmsEventSchedulingEventStarted(CHAR bookingId[],RmsEventBookingResponse eventBookingResponse)
{
    amx_log(AMX_ERROR,"'RmsEventSchedulingEventStarted(',eventBookingResponse.location,',' ,eventBookingResponse.subject,',',eventBookingResponse.elapsedMinutes,')'");
}

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

 integer TXT_MEET_SUBJECT = 101;
 integer TXT_MEET_TIME 	  = 102;
 integer BTN_MEET_CONFIRM = 100;
 
 

(***********************************************************)
(*                  THE EVENTS GO BELOW                    *)
(***********************************************************)
DEFINE_EVENT

button_event[dvTP_1_MEET, BTN_MEET_CONFIRM]
{
    push:
    {
	send_command button.input.device,"'^BSM-',itoa(TXT_MEET_SUBJECT),'&',itoa(TXT_MEET_TIME)"; 				// Returns strings with
    }
}
 
data_event[dvTP_1_MEET]
{
    string:
    {
	stack_var iCmd[DUET_MAX_CMD_LEN], iHeader[DUET_MAX_HDR_LEN], iParam[DUET_MAX_PARAM_LEN];
	local_var volatile char iSubject[100];
	local_var volatile integer iTime;

	iCmd = data.text;
	iHeader = DuetParseCmdHeader(iCmd);
	iParam = DuetParseCmdParam(iCmd);

	switch(iHeader)
	{
	    case 'SUBJECT':
	    {
		iSubject = iParam;
	    }
	    case 'TIME':
	    {
		iTime = atoi(iParam);
	    }
	}
	
	cancel_wait 'Create Meeting Debounce'
	wait 1 'Create Meeting Debounce'
	{
	    if(length_string(iSubject) && iTime) 
	    {
		RmsBookingCreate(LDATE, TIME, iTime, iSubject, 'Adhoc meeting request', 0);
		iSubject = "";
		iTime = 0;
	    }
	}	

    }
}





